unit VaxCall;

interface

  uses

     System.Classes,

    VaxCallSessionRoute,
    VaxDefine,
    VaxServerCOM,
    VaxServerExCOM;

type TVaxCall = class

    public

        constructor Create(); reintroduce; overload;

        function AcceptCallSession(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nToPeerType: Integer; sToPeerName: String; nTimeout: Integer) : boolean;

        function OnIncomingCall(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String; nToPeerType: Integer; sToPeerName: String) : Boolean;
        procedure OnCallSessionFailed(nSessionId: integer; nChannelId: Integer; nStatusCode: Integer; const sReasonPhrase: string);

        procedure OnCallSessionConnected(nSessionId: integer);
        procedure OnCallSessionClosed(nSessionId: integer; nChannelId: Integer; nReasonCode: Integer);

        procedure OnCallSessionConnecting(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; const sReasonPhrase: string);
        procedure OnCallSessionLost(nSessionId: Integer; nChannelId: Integer);
        procedure OnCallSessionHangup(nSessionId: Integer; nChannelId: Integer);
        procedure OnCallSessionTimeout(nSessionId: Integer; nChannelId: Integer);
        procedure OnCallSessionCancelled(nSessionId: Integer);

end;



implementation

        constructor TVaxCall.Create();
        begin
        end;

        function TVaxCall.AcceptCallSession(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nToPeerType: Integer; sToPeerName: String; nTimeout: Integer): Boolean;
        var
          bResult: Boolean;
        begin

            bResult := TVaxServerExCOM.mVaxExCOM.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName);

            if(bResult = False) then
            begin
              TVaxServerExCOM.mVaxExCOM.RejectCallSession(nSessionId, 404, 'Not Found');
              Exit(False);
            end;

            Result := True;

        end;

        function TVaxCall.OnIncomingCall(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String; nToPeerType: Integer; sToPeerName: String) : Boolean;
        begin

          if(nToPeerType = TVaxServerCOM.VAX_PEER_TYPE_LINE) Then
          begin

            sCallerName := '';
            sCallerId := '';

            // Let AcceptCallSession() use DisplayName & UserName values of LINE as CallerName & CallerId. Required by the ITSP (IP-Telephony service provider).
          end;

          if((sDialNo = '') Or (sToPeerName = '')) Then
            Exit(False);

           if(AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, 30) = False) then
            Exit(False);

           Result := True;

        end;

        procedure TVaxCall.OnCallSessionConnected(nSessionId: integer);
        begin
            //TVaxServerExCOM.mVaxExCOM.DetectDigitDTMF(nSessionId, TVaxServerCOM.VAX_CALL_CHANNEL_ZERO, TVaxServerCOM.VAX_DIGIT_DTMF_TYPE_RTP, True, TVaxServerCOM.VAX_PEER_TYPE_USER);
        end;

        procedure TVaxCall.OnCallSessionClosed(nSessionId: integer; nChannelId: Integer; nReasonCode: Integer);
        begin

        end;

        procedure TVaxCall.OnCallSessionConnecting(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; const sReasonPhrase: string);
        begin
           TVaxServerExCOM.mVaxExCOM.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, '');
        end;

        procedure TVaxCall.OnCallSessionFailed(nSessionId: integer; nChannelId: Integer; nStatusCode: Integer; const sReasonPhrase: string);
        begin
           TVaxServerExCOM.mVaxExCOM.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, '');
        end;

        procedure TVaxCall.OnCallSessionLost(nSessionId: Integer; nChannelId: Integer);
        begin

        end;

        procedure TVaxCall.OnCallSessionHangup(nSessionId: Integer; nChannelId: Integer);
        begin

        end;

        procedure TVaxCall.OnCallSessionTimeout(nSessionId: Integer; nChannelId: Integer);
        begin

        end;

        procedure TVaxCall.OnCallSessionCancelled(nSessionId: Integer);
        begin

        end;

end.

