﻿Public Class cStoreQueue
    Inherits cStoreRegistry

    Private Const QUEUE_ROOT_PATH = "Queues\\"

    Public Sub New()

    End Sub

    '///////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////

    Public Function AddQueue(ByVal sQueueName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.SetTEXT(sPath, "QueueName", sQueueName)

        Return True

    End Function

    Public Function RemoveQueue(ByVal sQueueName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.DeleteSubKey(sPath)

        Return True

    End Function

    Public Function GetQueueNameAll(ByRef objQueueList As List(Of String)) As Boolean

        objQueueList.Clear()

        Dim sPath As String = QUEUE_ROOT_PATH
        Return MyBase.EnumSubKeys(sPath, objQueueList)

    End Function

    Public Function SetMusicFile(ByVal sQueueName As String, ByVal sFileName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.SetTEXT(sPath, "MusicFileName", sFileName)

        Return True

    End Function

    Public Function GetMusicFile(ByVal sQueueName As String, ByRef sFileName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.GetTEXT(sPath, "MusicFileName", sFileName)

        Return True

    End Function

    Public Function SetDialToneFile(ByVal sQueueName As String, ByVal sFileName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.SetTEXT(sPath, "DialToneFileName", sFileName)

        Return True

    End Function

    Public Function GetDialToneFile(ByVal sQueueName As String, ByRef sFileName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.GetTEXT(sPath, "DialToneFileName", sFileName)

        Return True

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function SetQueueProcessMode(ByVal sQueueName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.SetINT(sPath, "ProcessMode", nProcessMode)
        MyBase.SetINT(sPath, "ProcessType", nProcessType)
        Return True

    End Function

    Public Function GetQueueProcessMode(ByVal sQueueName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        MyBase.GetINT(sPath, "ProcessMode", nProcessMode)
        MyBase.GetINT(sPath, "ProcessType", nProcessType)
        Return True

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function AddQueueAgent(ByVal sQueueName As String, ByVal sUserName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName

        Return MyBase.SetTEXT(sPath, "UserName", sUserName)

    End Function

    Public Function RemoveQueueAgent(ByVal sQueueName As String, ByVal sUserName As String) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName
        Return MyBase.DeleteSubKey(sPath)

    End Function

    Public Function GetQueueAgentNameAll(ByVal sQueueName As String, ByRef objQueueAgentList As List(Of String)) As Boolean

        objQueueAgentList.Clear()

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName
        Return MyBase.EnumSubKeys(sPath, objQueueAgentList)

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function SetQueueAgentPriority(ByVal sQueueName As String, ByVal sUserName As String, ByVal nPriority As Integer) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName
        MyBase.SetINT(sPath, "Priority", nPriority)
        Return True

    End Function

    Public Function GetQueueAgentPriority(ByVal sQueueName As String, ByVal sUserName As String, ByRef nPriority As Integer) As Boolean

        If (sQueueName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName

        MyBase.GetINT(sPath, "Priority", nPriority)
        Return True

    End Function

    Public Function IsDataStored() As Boolean
        Return MyBase.IsKeyExist(QUEUE_ROOT_PATH)
    End Function

End Class
