#include "StdAfx.h"
#include "cpu.h"

////////////////////////////////////////////////////////////

static ULARGE_INTEGER m_lastCPU, m_lastSysCPU, m_lastUserCPU;
static int m_numProcessors;
static HANDLE self;

CPU::CPU()
{
	SYSTEM_INFO sysInfo;
	FILETIME ftime, fsys, fuser;
    
	GetSystemInfo(&sysInfo);
	m_numProcessors = sysInfo.dwNumberOfProcessors;
    
	GetSystemTimeAsFileTime(&ftime);
	memcpy(&m_lastCPU, &ftime, sizeof(FILETIME));
    
	self = GetCurrentProcess();
	GetProcessTimes(self, &ftime, &ftime, &fsys, &fuser);
	
	memcpy(&m_lastSysCPU, &fsys, sizeof(FILETIME));
	memcpy(&m_lastUserCPU, &fuser, sizeof(FILETIME));
}

CPU::~CPU()
{

}

DWORD CPU::GetUsageCPU()
{
	
	FILETIME ftime, fsys, fuser;
	ULARGE_INTEGER now, sys, user;
	double percent;
    
	GetSystemTimeAsFileTime(&ftime);
    memcpy(&now, &ftime, sizeof(FILETIME));
    
    GetProcessTimes(self, &ftime, &ftime, &fsys, &fuser);
    memcpy(&sys, &fsys, sizeof(FILETIME));
    memcpy(&user, &fuser, sizeof(FILETIME));

    percent = (double) (sys.QuadPart - m_lastSysCPU.QuadPart) + (user.QuadPart - m_lastUserCPU.QuadPart);
    percent /= (now.QuadPart - m_lastCPU.QuadPart);
    percent /= m_numProcessors;
    
	m_lastCPU = now;
    m_lastUserCPU = user;
    m_lastSysCPU = sys;
    
    return DWORD (percent * 100);
}


