#include "StdAfx.h"
#include "RingGroupUserList.h"

CRingGroupUserDetails::CRingGroupUserDetails(LPCTSTR sUserName)
{
	m_sUserName = sUserName;
}

CRingGroupUserDetails::~CRingGroupUserDetails()
{
}

/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

CRingGroupUserList::CRingGroupUserList(void)
{
	m_pUserList = new CMapRingGroupUserList();
}

CRingGroupUserList::~CRingGroupUserList(void)
{
	DeleteAll();
	delete m_pUserList;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupUserList::DeleteAll()
{
	CRingGroupUserDetails* pUserDetail = NULL;
	CString sKey;

	POSITION pPos = m_pUserList->GetStartPosition();
	while(pPos != NULL)
	{
		m_pUserList->GetNextAssoc(pPos, sKey, pUserDetail);
		delete pUserDetail;
	}

	m_pUserList->RemoveAll();
}

CString CRingGroupUserList::GenKey(LPCTSTR sAgentName)
{
	CString sKey = sAgentName;
	sKey.MakeUpper();
	return sKey;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

BOOL CRingGroupUserList::AddAgent(LPCTSTR sAgentName)
{
	if(CString(sAgentName).IsEmpty())
		return FALSE;
	
	if(FindRingGroupUser(sAgentName) != NULL)
		return FALSE;

	CRingGroupUserDetails* pUserDetail = new CRingGroupUserDetails(sAgentName);
	pUserDetail->m_sUserName = sAgentName;

	CString sKey = GenKey(sAgentName);
	m_pUserList->SetAt(sKey, pUserDetail);
	
	return TRUE;
}

void CRingGroupUserList::RemoveAgent(LPCTSTR sAgentName)
{
	CRingGroupUserDetails* pUserDetail = NULL;
	
	CString sKey = GenKey(sAgentName);
	if(!m_pUserList->Lookup(sKey, pUserDetail)) return;
	
	delete pUserDetail;
	m_pUserList->RemoveKey(sKey);
}

int CRingGroupUserList::GetCount()
{
	return m_pUserList->GetCount();
}

CString CRingGroupUserList::GetRingGroupAgentAt(int nIndex)
{
	if (nIndex >= m_pUserList->GetCount())
		return "";
			
	CRingGroupUserDetails* pUserDetail = NULL;
	POSITION posAgentList = m_pUserList->GetStartPosition();
	
	for(int nAgentCount = 0; nAgentCount <= nIndex; nAgentCount++)
	{
		CString sAgentName;
		m_pUserList->GetNextAssoc(posAgentList, sAgentName, pUserDetail);
	}
	
	return pUserDetail->m_sUserName;
}

BOOL CRingGroupUserList::GetRingGroupAgentList(CStringList& sAgentNameList)
{
	POSITION posList = m_pUserList->GetStartPosition();
	
	CString sAgentName;
	CRingGroupUserDetails* pDetails;

	while(posList != NULL)
	{
		m_pUserList->GetNextAssoc(posList, sAgentName, pDetails);
		sAgentNameList.AddTail(pDetails->m_sUserName);
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

CRingGroupUserDetails* CRingGroupUserList::FindRingGroupUser(LPCTSTR sAgentName)
{
	CRingGroupUserDetails* pUserDetail = NULL;
	
	CString sKey = GenKey(sAgentName);
	if(!m_pUserList->Lookup(sKey, pUserDetail))
		return NULL;

	return pUserDetail;
}




