#include "stdafx.h"
#include "VaxCall.h"
#include "VaxServerExCOM.h"


CVaxCall::CVaxCall()
{
}

CVaxCall::~CVaxCall(void)
{
}

void CVaxCall::OnIncomingCall(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG lFromPeerType, LPCTSTR sFromPeerName, int nToPeerType, LPCTSTR sToPeerName, BOOL& bProcessed)
{
	bProcessed = FALSE;

	if(CString(sDialNo).IsEmpty() ||(CStringA (sToPeerName).IsEmpty()))
	{
		ASSERT(FALSE);
		return;
	}

	if(nToPeerType == VAX_PEER_TYPE_LINE)
	{
		sCallerId = "";
		sCallerName = "";

		// Let AcceptCallSession() use DisplayName & UserName values of LINE as CallerName & CallerId. Required by the ITSP (IP-Telephony service provider).
	}

	bProcessed = TRUE;

	if(!CVaxServerExCOM::m_pVaxServerExCOM->AcceptCallSession(lSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, 30))
	{
		CVaxServerExCOM::m_pVaxServerExCOM->RejectCallSession(lSessionId, 404, "Not Found");
		return;
	}
}

void CVaxCall::OnCallSessionFailed(LONG lSessionId, int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	CVaxServerExCOM::m_pVaxServerExCOM->CallSessionSendStatusResponse(lSessionId, lStatusCode, sReasonPhrase, "");
}

void CVaxCall::OnCallSessionConnecting(LONG lSessionId, int nChannelId, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	CVaxServerExCOM::m_pVaxServerExCOM->CallSessionSendStatusResponse(lSessionId, lStatusCode, sReasonPhrase, "");
}

void CVaxCall::OnCallSessionConnected(LONG lSessionId)
{
	CVaxServerExCOM::m_pVaxServerExCOM->RecordWaveStartToCallSession(lSessionId, VAX_CALL_CHANNEL_ZERO, "Record.wav");
}

void CVaxCall::OnCallSessionLost(LONG lSessionId, int nChannelId)
{
}
void CVaxCall::OnCallSessionHangup(LONG lSessionId, int nChannelId)
{
}
void CVaxCall::OnCallSessionTimeout(LONG lSessionId, int nChannelId)
{
}
void CVaxCall::OnCallSessionCancelled(LONG lSessionId)
{
}
