#include "stdafx.h"
#include "VaxQueue.h"
#include "VaxServerExCOM.h"

CVaxQueue::CVaxQueue()
{
}

CVaxQueue::~CVaxQueue(void)
{
}

void CVaxQueue::OnIncomingCall(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sQueueName, BOOL& bProcessed)
{
	bProcessed = FALSE;
	
	if(CString(sQueueName).IsEmpty())
		return;

	bProcessed = TRUE;

	if(!CVaxServerExCOM::m_pVaxServerExCOM->AddCallSessionToQueue(sQueueName, sCallerName, sCallerId, lSessionId, 20))
		return;

}

void CVaxQueue::OnAddCallSessionToQueueSuccess(LPCTSTR sQueueName, LONG lSessionId)
{
}

void CVaxQueue::OnAddCallSessionToQueueFailed(LPCTSTR sQueueName, LONG lSessionId)
{
}

void CVaxQueue::OnQueuePlayWaveStart(int nEventType, LPCTSTR sQueueName, LONG lSessionId)
{
	if(nEventType == VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC)
	{
		int nQueueMusicId = CVaxServerExCOM::m_pVaxServerExCOM->GetQueueMusicId(sQueueName);

		if(nQueueMusicId != -1)
		{
			CVaxServerExCOM::m_pVaxServerExCOM->PlayWaveStartToCallSession(lSessionId, VAX_CALL_CHANNEL_ZERO, nQueueMusicId, TRUE, 10);
			return;
		}
	}

	int nQueueDialToneId = CVaxServerExCOM::m_pVaxServerExCOM->GetQueueDialToneId(sQueueName);

	if(nQueueDialToneId == -1)
		return;

	CVaxServerExCOM::m_pVaxServerExCOM->PlayWaveStartToCallSession(lSessionId, VAX_CALL_CHANNEL_ZERO, nQueueDialToneId, TRUE, 10);

}

void CVaxQueue::OnQueuePlayWaveStop(int nEventType, LPCTSTR sQueueName, LONG lSessionId)
{
	if(nEventType == VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC)
	{
		int nQueueMusicId = CVaxServerExCOM::m_pVaxServerExCOM->GetQueueMusicId(sQueueName);

		if(nQueueMusicId != -1)
		{
			CVaxServerExCOM::m_pVaxServerExCOM->PlayWaveStopToCallSession(lSessionId, VAX_CALL_CHANNEL_ZERO, nQueueMusicId);
			return;
		}
	}

	int nQueueDialToneId = CVaxServerExCOM::m_pVaxServerExCOM->GetQueueDialToneId(sQueueName);

	if(nQueueDialToneId == -1)
		return;

	CVaxServerExCOM::m_pVaxServerExCOM->PlayWaveStopToCallSession(lSessionId, VAX_CALL_CHANNEL_ZERO, nQueueDialToneId);
}
