#pragma once

#include "VaxServerCOM.h"

class CConfRoom;
class CVaxChat;
class CVaxCallSessionRoute;

class CQueueList;
class CRingGroupList;
class CCallPickUpList;
class CVaxRegUserList;
class CVaxUserList;

class CVaxServerExCOM :	public CVaxServerCOM
{

public:
	
	CVaxServerExCOM();
	~CVaxServerExCOM();

private:

	CConfRoom* m_pConfRoom;
	CVaxChat* m_pChat;

	BOOL m_bInitilized;

	CQueueList* m_pQueueList;
	CRingGroupList* m_pRingGroupList;
	CCallPickUpList* m_pCallPickUpList;
	CVaxRegUserList* m_pRegUserList;

	CVaxCallSessionRoute* m_pRouteCallSIP;

	LONG m_lDialToneId;
	LONG m_lMusicCallParkId;
			
	CRITICAL_SECTION m_lCriticalSection;

public:

	CString m_sLicenseKey;

	static CVaxServerExCOM* m_pVaxServerExCOM;

public:

	BOOL IsInitialized();

	BOOL GetCOMM(CString& sDomainRealm, CString& sSIPListenIP, UINT& nSIPListenPort, CString& sRTPListenIP, UINT& nRTPListenPort);

	void SetLicenseKey(LPCTSTR sLicenseKey);
	
	BOOL Initialize(LPCTSTR sDomainRealm, LPCTSTR sSIPListenIP, UINT nSIPListenPort, LPCTSTR sRTPListenIP, UINT nRTPListenPort);
	void UnInitialize();
		
	BOOL AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName, BOOL bStealthlisten);
	BOOL AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sCodecList);
	void RemoveUser(LPCTSTR sUserName);

	BOOL IsUserExist(LPCTSTR sUserName);
	
	void GetUserData(LPCTSTR sUserName, CString& sPassword, CString& sCodecList, BOOL& bBlocked, CString& sUserPrefix, CString& sDialPrefix, int& nToPeerType, CString& sToPeerName, BOOL& bStealthlisten);
	
	BOOL AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveLine(LPCTSTR sLineName);
	BOOL IsLineExist(LPCTSTR sLineName);
		
	BOOL AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveDirectProxySIP(LPCTSTR sProxyName);
	BOOL IsProxyExist(LPCTSTR sProxyName);

	LONG GetVaxErrorCode();

	BOOL DialToneToCallSession(BOOL bEnable, LONG lSessionId);
	BOOL DiagnosticLogSIP(BOOL bInbound, BOOL bOutbound);

	/////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////// RingGroup  ////////////////////////////////////////////

	BOOL AddRingGroup(LPCTSTR sRingGroupName);
	void RemoveRingGroup(LPCTSTR sRingGroupName);
	
	BOOL GetRingGroupDetails(LPCTSTR sRingGroupName, int& nProcessMode, int& nProcessType, CStringList& sListAgentName);

	BOOL AddRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sUserName);
	void RemoveRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sUserName);

	void SetRingGroupProcessMode(LPCTSTR sRingGroupName, int nProcessMode, int nProcessType);
	BOOL SetRingGroupAgentPriority(LPCTSTR sRingGroupName, LPCTSTR sAgentName, int nPriority);

	BOOL AddCallSessionToRingGroup(LPCTSTR sRingGroupName, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG lSessionId);

	//////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////

	BOOL AddCallPickUpGroup(LPCTSTR sPickupGroupName);
	void RemoveCallPickUpGroup(LPCTSTR sPickupGroupName);
	
	BOOL AddCallPickUpGroupMember(LPCTSTR sPickupGroupName, LPCTSTR sMemberName);
	void RemoveCallPickUpGroupMember(LPCTSTR sPickupGroupName, LPCTSTR sMemberName);
		
	BOOL PickUpCall(LONG lSessionId,  LPCTSTR sMemberName);

	//////////////////////////////////////////////////////////////////////////////

	BOOL AddQueue(LPCTSTR sQueueName, LPCTSTR sQueueMusicFile, LPCTSTR sQueueDialToneFile);
	void RemoveQueue(LPCTSTR sQueueName);

	int GetQueueMusicId(LPCTSTR sQueueName);
	int GetQueueDialToneId(LPCTSTR sQueueName);
	
	BOOL AddQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);
	void RemoveQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);
	void SetQueueAgentPriority(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG lPriority);

	void SetQueueProcessMode(LPCTSTR sQueueName, int nProcessMode, int nProcessType);
		
public:

	BOOL AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo);
	void RemoveRoom(LPCTSTR sRoomName);

	BOOL GetRoomDetails(LPCTSTR sRoomName, CString& sRoomNo);
	BOOL GetRoomAll(CStringList* pRoomList);

	BOOL IsRoomNoExist(LPCTSTR sRoomNo);
	CString GetRoomName(LPCTSTR sRoomNo);

	
	BOOL GetUserRouteInfo(LPCTSTR sUserName, LPCTSTR sUserDialedNo, CString& sDialNo, LONG& lToPeerType, CString& sToPeerName);
	BOOL GetLineRouteInfo(LPCTSTR sLineName, LONG& lToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);
	BOOL GetDirectProxyRouteInfo(LPCTSTR sProxyName, LONG& lToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);
	
public:

	BOOL AddUserRoute(LPCTSTR sUserName, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName);
	void RemoveUserRoute(LPCTSTR sUserName);

	BOOL AddLineRoute(LPCTSTR sLineName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveLineRoute(LPCTSTR sLineName);

	BOOL AddDirectProxyRoute(LPCTSTR sProxyName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveDirectProxyRoute(LPCTSTR sProxyName);

public:

	BOOL LoadDialToneMusic(LPCTSTR sFileName);
	void UnLoadDialToneMusic();

	BOOL LoadMusicCallPark(LPCTSTR sFileName);
	void UnLoadMusicCallPark();

	LONG GetCallParkMusicId();
    LONG GetCallCount();
	
private:

	void DeleteCallSessionDataAll();
	void DeleteUserDataAll();
	void DeleteLineDataAll();

	void GetFromPeerRouteinfo(LONG lFromPeerType, LPCTSTR sDialNo, LPCTSTR sFromPeerName, CString& sToPeerName, CString& sDialToNo, CString& sRoomName, CString& sRingGroupName, CString& sQueueName, LONG& lToPeerType,  BOOL& bRejected);

public:

	UINT GetRegisteredUserCount();
	BOOL VoiceSessionLost(BOOL bEnable, LONG lTimeout);

private:

	void GenStatusLog(LPCTSTR sStatus);
					
public:

	void OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnUnRegisterUser(LPCTSTR sUserLogin);
		
	void OnCallSessionConnecting(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionFailed(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionConnected(LONG nSessionId);

	void OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort);
	
	void OnCallSessionCreated(LONG nSessionId, LONG nReasonCode);
	void OnCallSessionClosed(LONG nSessionId, LONG nChannelId, LONG nReasonCode);

	void OnCallSessionLost(LONG nSessionId, LONG nChannelId);
	void OnCallSessionHangup(LONG nSessionId, LONG nChannelId);
	void OnCallSessionTimeout(LONG nSessionId, LONG nChannelId);
	void OnCallSessionCancelled(LONG nSessionId);
	
	void OnCallSessionOnHold(LONG nSessionId, LONG nChannelId);
	void OnCallSessionOffHold(LONG nSessionId, LONG nChannelId);

	void OnCallSessionTransferBlind(LONG nTransfererSessionId, LONG nTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
	void OnCallSessionTransferConsult(LONG nTransfererSessionId, LONG nTransfereeSessionId, LONG nTransferToSessionId, LONG nTransfererChannelId, LONG nTransfereeChannelId, LONG nTransferToChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
	
	void OnCallSessionTransfering(LONG nSessionId, LONG nTransferType, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionTransferFailed(LONG nSessionId, LONG nTransferType, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionTransferTimeout(LONG nSessionId, LONG nTransferType, LONG nChannelId);
	void OnCallSessionTransfered(LONG nSessionId, LONG nTransferType);

	void OnLineRegisterTrying(LPCTSTR sLineName);
	void OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnLineRegisterSuccess(LPCTSTR sLineName);

	void OnLineUnRegisterTrying(LPCTSTR sLineName);
	void OnLineUnRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnLineUnRegisterSuccess(LPCTSTR sLineName);
		
	void OnChatMessageText(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	void OnChatMessageTyping(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, BOOL IsTypingStart, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	
	void OnChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);

	void OnChatMessageSuccess(LONG nChatMsgId);
	void OnChatMessageFailed(LONG nChatMsgId, LONG nStatusId, LPCTSTR sReasonPhrase);
	void OnChatMessageTimeout(LONG nChatMsgId);

	void OnOutgoingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sToIP, LONG nToPort);
	void OnIncomingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sFromIP, LONG nFromPort);

	void OnDetectedDigitDTMF(LONG nSessionId, LONG nChannelId, LPCTSTR sDigitDTMF);
	void OnVaxTeleTick(LONG nTickId);

	void OnSendTimeoutVM(LONG nMsgIdVM);
	void OnSendSuccessVM(LONG nMsgIdVM);

	void OnCallSessionDialToneStart(LONG nSessionId, LONG nChannelId, LONG nWaveId);
	void OnCallSessionDialToneStop(LONG nSessionId, LONG nChannelId, LONG nWaveId);

	void OnCallSessionPlayWaveDone(LONG nSessionId, LONG nChannelId, LONG nWaveId);
	void OnConferenceRoomPlayWaveDone(LPCTSTR sRoomName, LONG nWaveId);
		
	void OnCallSessionDetectedAMD(LONG nSessionId, LONG nChannelId, BOOL bIsHuman);

	void OnCallSessionRecordedPCM(LONG nSessionId, LONG nChannelId, LONGLONG nDataPCM, LONG nSizePCM, LONG nTypePCM);
	void OnConferenceRoomRecordedPCM(LPCTSTR sRoomName, LONGLONG nDataPCM, LONG nSizePCM, LONG nTypePCM);

	void OnBusyLampSubscribe(LONG nSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort);
	void OnBusyLampUnSubscribe(LONG nSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort);
	void OnBusyLampSubscribeSuccess(LONG nSubScrbId, LPCTSTR sUserName);
	void OnBusyLampSubscribeFailed(LONG nSubScrbId, LPCTSTR sUserName);
	void OnBusyLampSendStatus(LPCTSTR sFromUserName, LPCTSTR sToUserName, LONG nStateId);

	void OnVaxErrorLog(LPCTSTR sFuncName, LONG nErrorCode, LPCTSTR sErrorMsg);
	void OnVaxLicenseChannel(LONG nTotalChannels, LONG nUsedChannels);
	
	void OnAddCallSessionToQueueSuccess(LPCTSTR sQueueName, LONG nSessionId);
	void OnAddCallSessionToQueueFailed(LPCTSTR sQueueName, LONG nSessionId);

	void OnQueuePlayWaveStart(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);
	void OnQueuePlayWaveStop(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);

	void OnAddCallSessionToRingGroupSuccess(LPCTSTR sGroupName, LONG nSessionId);
	void OnAddCallSessionToRingGroupFailed(LPCTSTR sGroupName, LONG nSessionId);

protected:

	virtual void OnInitialize();
	virtual void OnStatusLog(LPCTSTR sMsg);
	virtual void OnErrorLog(LPCTSTR sMsg);
	

};


