unit GeneralDlg;

interface

uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  System.Variants,
  System.Classes,
  Vcl.Graphics,
  Vcl.Controls,
  Vcl.Forms,
  Vcl.Dialogs,
  Vcl.StdCtrls,
  Vcl.ExtCtrls,

  VaxTeleServerSIP;

type TGeneralForm = class(TForm)

    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;

    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;

    EditListenIP: TEdit;
    EditListenPort: TEdit;
    EditPlayWaveHold: TEdit;
    EditPlayWaveDialTone: TEdit;

    btnStartServerSIP: TButton;
    btnStopServerSIP: TButton;

    LabelServerStatus: TLabel;
    LabelTotalCalls: TLabel;
    LabelTotalUsers: TLabel;
    LabelUsageCPU: TLabel;
    LabelAvailabeMem: TLabel;

    TimerGeneral: TTimer;

    procedure TimerGeneral_Tick(Sender: TObject);
    procedure btnStartServerSIPClick(Sender: TObject);
    procedure btnStopServerSIPClick(Sender: TObject);

  public

    constructor Create(); overload;
    constructor Create(AOwner : TComponent; var pVaxTeleSIP : TVaxTeleServerSIP); reintroduce; overload;

  private

    procedure UpdateStats();
    procedure AddUsers;

  public
    procedure StopServer();
    procedure OnSetActive();

  end;

var
  GeneralForm: TGeneralForm;
  m_pVaxTeleSIP : TVaxTeleServerSIP;

implementation

{$R *.dfm}

    constructor TGeneralForm.Create();
    begin
    end;

    constructor TGeneralForm.Create(AOwner : TComponent; var pVaxTeleSIP : TVaxTeleServerSIP);
    begin
        inherited Create(AOwner);
        m_pVaxTeleSIP := pVaxTeleSIP;
    end;

    procedure TGeneralForm.btnStartServerSIPClick(Sender: TObject);
    var
      sDomainRealm, sListenIP : string;
      nListenPort: Integer;
      bResult: Boolean;
    begin

        sListenIP := EditListenIP.Text;
        nListenPort := StrToInt(EditListenPort.Text);
        sDomainRealm := sListenIP;

        m_pVaxTeleSIP.SetLicenseKey('TRIAL-LICENSE-KEY');

        bResult := m_pVaxTeleSIP.Initialize(sDomainRealm, sListenIP, nListenPort, sListenIP, -1);

        if(bResult = False) then
        begin
          LabelServerStatus.Caption := AnsiUpperCase('Server Not Started.');
          Exit();
        end;

        AddUsers();

        LabelServerStatus.Caption := AnsiUpperCase('Server Started.');

        m_pVaxTeleSIP.LoadMusicHold(EditPlayWaveHold.Text);
        m_pVaxTeleSIP.LoadMusicDialTone(EditPlayWaveDialTone.Text);

        TimerGeneral.Enabled := True;

    end;

    procedure TGeneralForm.btnStopServerSIPClick(Sender: TObject);
    begin
        StopServer();
    end;

    procedure TGeneralForm.StopServer();
    begin

        m_pVaxTeleSIP.UnInitialize();

        LabelServerStatus.Caption := AnsiUpperCase('Server Not Running');
        TimerGeneral.Enabled := False;

    end;

    procedure TGeneralForm.OnSetActive();
    begin
      //
    end;

    procedure TGeneralForm.TimerGeneral_Tick(Sender: TObject);
    begin
        UpdateStats();
    end;

    procedure TGeneralForm.UpdateStats();
    begin

      LabelTotalCalls.Caption := 'Total Calls: ' + IntToStr(m_pVaxTeleSIP.GetCallCount());
      LabelTotalUsers.Caption := 'Total Users: ' + IntToStr(m_pVaxTeleSIP.GetRegUserCount());

      LabelUsageCPU.Caption := 'CPU Usage (%) : ' + IntToStr(m_pVaxTeleSIP.GetUsageCPU());
      LabelAvailabeMem.Caption := 'Available Memory (M) : ' + IntToStr(m_pVaxTeleSIP.GetAvailableMEM());

    end;

    procedure TGeneralForm.AddUsers();
    var
      sLogin, sPassword : string;
      nIndex : Integer;
    begin

      for nIndex := 4040 to 4050 do
      begin
        sLogin := IntToStr(nIndex);
        sPassword := sLogin;

        m_pVaxTeleSIP.RemoveUser(sLogin);
        m_pVaxTeleSIP.AddUser(sLogin, sPassword, '32014', False, '', '', -1, '')
      end;

    end;
end.
