// VaxTeleServerAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "VaxTeleServerAppDlg.h"
#include "AddLineDlg.h"
#include "AddDirectProxyDlg.h"
#include "AddLoginDlg.h"
#include "GeneralDlg.h"
#include "ErrorLogDlg.h"
#include "StatusLogDlg.h"
#include "AddConferenceDlg.h"


#ifdef _DEBUG
	#define new DEBUG_NEW
	#undef THIS_FILE
	static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVaxTeleServerAppDlg dialog

IMPLEMENT_DYNAMIC(CVaxTeleServerAppDlg, CMySheet)

CVaxTeleServerAppDlg* CVaxTeleServerAppDlg::m_pVaxTeleServerAppDlg = NULL;

CVaxTeleServerAppDlg::CVaxTeleServerAppDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CMySheet(nIDCaption, pParentWnd, iSelectPage)
{
}

CVaxTeleServerAppDlg::CVaxTeleServerAppDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CMySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_pVaxTeleSIP = new CVaxServerSIP();

	CVaxTeleServerAppDlg::m_pVaxTeleServerAppDlg = this;
	
	m_psh.dwFlags |= PSH_NOAPPLYNOW;   // Lose the Apply Now button
	m_psh.dwFlags &= ~PSH_HASHELP;     // Lose the Help button
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	m_pAddLoginDlg			= new CAddLoginDlg(m_pVaxTeleSIP);
	m_pGeneralDlg			= new CGeneralDlg(m_pVaxTeleSIP);
	
	m_pAddLineDlg			= new CAddLineDlg(m_pVaxTeleSIP);
	m_pAddDirectProxyDlg	= new CAddDirectProxyDlg(m_pVaxTeleSIP);
	m_pAddConferenceDlg		= new CAddConferenceDlg(m_pVaxTeleSIP);
	
	m_pErrorLogDlg			= new CErrorLogDlg;
	m_pVaxTeleSIP->m_pErrorLogDlg = m_pErrorLogDlg;
	
	m_pStatusLogDlg			= new CStatusLogDlg;
	m_pVaxTeleSIP->m_pStatusLogDlg = m_pStatusLogDlg;
	
	AddPage(m_pGeneralDlg);
	AddPage(m_pAddLoginDlg);

	AddPage(m_pAddLineDlg);
	AddPage(m_pAddDirectProxyDlg);
	AddPage(m_pAddConferenceDlg);

	AddPage(m_pErrorLogDlg);
	AddPage(m_pStatusLogDlg);
}

CVaxTeleServerAppDlg::~CVaxTeleServerAppDlg()
{
	delete m_pAddLoginDlg;
	delete m_pGeneralDlg;

	delete m_pAddLineDlg;
	delete m_pAddDirectProxyDlg;
	delete m_pAddConferenceDlg;

	delete m_pErrorLogDlg;
	delete m_pStatusLogDlg;

	delete m_pVaxTeleSIP;
}

BEGIN_MESSAGE_MAP(CVaxTeleServerAppDlg, CMySheet)
	//{{AFX_MSG_MAP(CVaxTeleServerAppDlg)
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_NCCREATE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVaxTeleServerAppDlg message handlers

BOOL CVaxTeleServerAppDlg::OnInitDialog() 
{
	BOOL bResult = CMySheet::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	// Get size in RECT structure
	RECT rcVaxTeleServerAppDlg;
	GetWindowRect (&rcVaxTeleServerAppDlg);

	ScreenToClient (&rcVaxTeleServerAppDlg);

	// Decrease it's bottom's size
	rcVaxTeleServerAppDlg.bottom -= 12;

	// Apply new size to this CPropertySheet
	SetWindowPos(NULL, 0,0, rcVaxTeleServerAppDlg.right, rcVaxTeleServerAppDlg.bottom, SWP_SHOWWINDOW | SWP_NOMOVE);

	//
	((CButton*) GetDlgItem(IDOK))->ShowWindow(SW_HIDE);
	((CButton*) GetDlgItem(IDCANCEL))->ShowWindow(SW_HIDE);

	return bResult;
}

HCURSOR CVaxTeleServerAppDlg::OnQueryDragIcon() 
{
	return (HCURSOR) m_hIcon;
}


BOOL CVaxTeleServerAppDlg::OnNcCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (!CMySheet::OnNcCreate(lpCreateStruct))
		return FALSE;

	LONG dwStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
	::SetWindowLong(m_hWnd, GWL_STYLE, dwStyle | WS_MINIMIZEBOX);

	return TRUE;
}
