﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cVaxLine
    {
        cVaxServerExCOM m_objServerExCOM = null;

        public string m_sDisplayName, m_sUserName, m_sAuthUser, m_sAuthPwd;
        public string m_sDomainRealm, m_sProxySIP, m_sCodecList, m_sToPeerName, m_sRoomName;
        public bool m_bRegister = false, m_bBlock = false;

        public int m_nToPeerType = -1;

        public cVaxLine(cVaxServerExCOM objServerExCOM)
        {
            m_objServerExCOM = objServerExCOM;
        }

        ~cVaxLine()
        {
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public void OnLineRegisterTrying(string sLineName)
        {
            string sStatus = sLineName + " " + CDefine.LINE_REG_TRYING;
            m_objServerExCOM.GenStatusLog(sStatus);
        }

        public void OnLineRegisterFailed(string sLineName, int nStatusCode, string sReasonPhrase)
        {
            string sStatus = sLineName + " Register Failed: " + sReasonPhrase;
            m_objServerExCOM.GenStatusLog(sStatus);
        }

        public void OnLineRegisterSuccess(string sLineName)
        {
            string sStatus = sLineName + " " + CDefine.LINE_REG_SUCCESS;
            m_objServerExCOM.GenStatusLog(sStatus);
        }

        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////
        
	    public void GetData(ref string sDisplayName, ref string sUserName, ref string sAuthUser, ref string sAuthPwd, ref string sDomainRealm, ref string sProxySIP, ref string sCodecList, ref bool bRegister, ref int nToPeerType, ref string sToPeerName, ref bool bBlock, ref string sRoomName)
        {
            sDisplayName = m_sDisplayName;
            sUserName = m_sUserName;
            sAuthUser = m_sAuthUser;
            sAuthPwd = m_sAuthPwd;

            sDomainRealm = m_sDomainRealm;
            sProxySIP = m_sProxySIP;
            sCodecList = m_sCodecList;

            bRegister = m_bRegister;
            bBlock = m_bBlock;

            nToPeerType = m_nToPeerType;
            sToPeerName = m_sToPeerName;
            sRoomName = m_sRoomName;
        }

        public void SetData(string sDisplayName, string sUserName, string sAuthUser, string sAuthPwd, string sDomainRealm, string sProxySIP, string sCodecList, bool bRegister, int nToPeerType, string sToPeerName, bool bBlock, string sRoomName)
        {
            m_sDisplayName = sDisplayName;
            m_sUserName = sUserName;
            m_sAuthUser = sAuthUser;
            m_sAuthPwd = sAuthPwd;

            m_sDomainRealm = sDomainRealm;
            m_sProxySIP = sProxySIP;
            m_sCodecList = sCodecList;

            m_bRegister = bRegister;
            m_bBlock = bBlock;
            
            m_nToPeerType = nToPeerType;
            m_sToPeerName = sToPeerName;
            m_sRoomName = sRoomName;
        }
                
        //////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////
        
    }
}
